package de.lluni.javann.examples;

import de.lluni.javann.util.GradientDescent;
import org.ejml.simple.SimpleMatrix;

import java.util.function.Function;

public class ExampleGradientDescent {
    public static void main(String[] args) {
        GradientDescent gd = new GradientDescent();

        Function<Double, Double> f = x -> x*x;
        System.out.println(gd.findLocalMinimum(f, 1));

        Function<SimpleMatrix, SimpleMatrix> g = x -> x.elementMult(x);
        SimpleMatrix initialX = new SimpleMatrix(2, 1, true, new double[]{1, 0.5});
        System.out.println(gd.findLocalMinimum(g, initialX));
    }
}
